## nocache 0.9

=== Makefile ===
default: all
all: cachestats cachedel nocache.so
.PHONY: test

GCC = gcc $(CFLAGS)
%.c: Makefile
cachestats: cachestats.c
	$(GCC) -Wall -o cachestats cachestats.c
cachedel: cachedel.c
	$(GCC) -Wall -o cachedel cachedel.c
nocache.o: nocache.c
	$(GCC) -Wall -fPIC -c -o nocache.o nocache.c
fcntl_helpers.o: fcntl_helpers.c
	$(GCC) -Wall -fPIC -c -o fcntl_helpers.o fcntl_helpers.c
nocache.so: nocache.o fcntl_helpers.o
	$(GCC) -Wall -pthread -shared -Wl,-soname,nocache.so -o nocache.so nocache.o fcntl_helpers.o -ldl

install: all
	install -m 0644 nocache.so /usr/local/lib
	install -m 0755 nocache.global /usr/local/bin/nocache

test:
	cd t; prove -v .

clean:
	rm -f cachestats cachedel fcntl_helpers.o nocache.o nocache.so

=== debian/changelog ===
nocache (0.9-2) unstable; urgency=medium

  * Disabled freezing post-build tests to fix FTBFS (Closes: #746888).
  * Standards-Version to 3.9.5.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 01 Jun 2014 19:53:43 +1000

nocache (0.9-1) unstable; urgency=low

  * New upstream release [May 2013].
    + dropped "man.patch" (applied-upstream).
  * New "make.patch" to rewrite Makefile from scratch in usable way.
    + simplified rules, let Makefile do the job.
  * No longer use our executable wrapper template (Closes: #710019).
  * Use NOCACHE_NR_FADVISE=2 for post-build tests to fix often failing
    test #3 and to test FADVISE>1.
  * get-orig-source to checkout tag and to set timestamp of generated
    ChangeLog to commit date.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 31 May 2013 00:06:53 +1000

nocache (0.8+git20130430-1) unstable; urgency=low

  * New upstream release [April 2013].
  * Removed our man pages and ship upstream ones (our man pages were
    accepted and improved upstream).
  * New patch to fix "hyphen-used-as-minus-sign" in man pages.
  * get-orig-source improved to produce identical orig.tar (when
    possible) with accurate file's timestamps.
  * debian/watch to mangle debian version.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 02 May 2013 11:44:54 +1000

nocache (0+git20121017-2) unstable; urgency=low

  * Fixed Issue #5: extend (not override) LD_PRELOAD.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 18 Apr 2013 12:27:13 +1000

nocache (0+git20121017-1) unstable; urgency=low

  * Initial release (Closes: #702854).

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 18 Mar 2013 00:32:17 +1100

=== debian/control ===
Source: nocache
Section: utils
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 9)
# git is needed by get-orig-source
 ,git
Standards-Version: 3.9.5
Homepage: https://github.com/Feh/nocache
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/nocache.git
Vcs-Git: git://anonscm.debian.org/collab-maint/nocache.git

Package: nocache
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: bypass/minimize file system caching for a program
 `nocache` tries to minimize the effect an application has on the Linux
 file system cache.
 .
 Use case: backup processes that should not interfere with the present
 state of the cache.
 .
 Also this package provides the following utilities:
 * `cachedel`   : clear page cache for a file.
 * `cachestats` : print number of cached vs. not-cached pages for a file

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -v -- PREFIX=/usr LIBDIR=/lib/$(PKG)
	# check if wrapper built for correct PREFIX and LIBDIR
	[ -n "$$(grep '/usr/lib/$(PKG)/$(PKG)' $(CURDIR)/debian/$(PKG)/usr/bin/$(PKG))" ]

override_dh_auto_test:
#	-NOCACHE_NR_FADVISE=2 dh_auto_test -v

override_dh_builddeb:
	dh_builddeb -- -Zxz

PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
VER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{Version:\s*([\d\.+git]+)}')
GDATE = $(shell date --rfc-3339=seconds --date='TZ="UTC" $(shell echo $(VER) | perl -ne 'print "$$1-$$2-$$3" if m/\+git(\d{4})(\d{2})(\d{2})/')')
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(VER).orig.tar.xz
	@

$(PKG)_$(VER).orig.tar.xz:
	@echo "# Downloading..."
	#uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)
	git clone git://github.com/Feh/nocache.git $(PKG)-$(VER) \
        || $(RM) -r $(PKG)-$(VER)
	cd $(PKG)-$(VER) \
        && git checkout v$(VER) || git reset --hard $$(git rev-list --all -n 1 --before="$(GDATE)") \
        && [ -s ChangeLog ] || ( echo "# Generating ChangeLog..." \
           ; git log --pretty="format:%ad  %aN  <%aE>%n%n%x09* %s%n" --date=short > ChangeLog \
           ; touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
        && echo "# Setting times..." \
        && for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
        && echo "# Cleaning-up..." \
        && $(RM) -rv .git .git* \
        && cd .. && echo "# Packing..." \
        && find -L "$(PKG)-$(VER)" -xdev -type f -print \
        | sort | XZ_OPT="-7v" tar -caf "$(PKG)_$(VER).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
        && $(RM) -r "$(PKG)-$(VER)"

## nocache 1.0

=== Makefile ===
#!/usr/bin/make -f
# -*- makefile -*-

PREFIX ?= /usr/local
MANDIR ?= /share/man/man1
BINDIR ?= /bin
LIBDIR ?= /lib
mandir  = $(DESTDIR)$(PREFIX)$(MANDIR)
bindir  = $(DESTDIR)$(PREFIX)$(BINDIR)
libdir  = $(DESTDIR)$(PREFIX)$(LIBDIR)

CACHE_BINS=cachedel cachestats
NOCACHE_BINS=nocache.o fcntl_helpers.o pageinfo.o
MANPAGES=$(wildcard man/*.1)

CC ?= gcc
CFLAGS+= -Wall
COMPILE = $(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS)

.PHONY: all
all: $(CACHE_BINS) nocache.so nocache

$(CACHE_BINS):
	$(COMPILE) -o $@ $@.c

$(NOCACHE_BINS): $(NOCACHE_BINS:.o=.c)
	$(COMPILE) -fPIC -c -o $@ $(@:.o=.c)

nocache.global: nocache.in
	sed 's!##libdir##!$(subst $(DESTDIR),,$(libdir))!' <nocache.in >$@

nocache: nocache.in
	sed 's!##libdir##!$$(dirname "$$0")!' <nocache.in >$@
	chmod a+x $@

nocache.so: $(NOCACHE_BINS)
	$(COMPILE) -pthread -shared -Wl,-soname,nocache.so -o nocache.so $(NOCACHE_BINS) -ldl

$(mandir) $(libdir) $(bindir):
	mkdir -v -p $@

install: all $(mandir) $(libdir) $(bindir) nocache.global
	install -pm 0644 nocache.so $(libdir)
	install -pm 0755 nocache.global $(bindir)/nocache
	install -pm 0755 $(CACHE_BINS) $(bindir)
	install -pm 0644 $(MANPAGES) $(mandir)

.PHONY: uninstall
uninstall:
	cd $(mandir) && $(RM) -v $(notdir $(MANPAGES))
	$(RM) -v $(bindir)/nocache $(libdir)/nocache.so

.PHONY: clean distclean
clean distclean:
	$(RM) -v $(CACHE_BINS) $(NOCACHE_BINS) nocache.so nocache nocache.global

.PHONY: test
test: all
	cd t; prove -v .

=== debian/changelog ===
nocache (1.0-1) unstable; urgency=medium

  * New upstream release [May 2016].
  * Removed obsolete "make.patch".
  * Modernised Vcs URLs.
  * Updated get-orig-source.
  * Standards-Version: 3.9.8.
  * Build with full hardening.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 21 May 2016 14:13:28 +1000

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Build-Depends: debhelper (>= 9)
 # git is needed by get-orig-source
  ,git
-Standards-Version: 3.9.5
+Standards-Version: 3.9.8
 Homepage: https://github.com/Feh/nocache
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/nocache.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/nocache.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/nocache.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/nocache.git
 
 Package: nocache
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -v -- PREFIX=/usr LIBDIR=/lib/$(PKG)
	# check if wrapper built for correct PREFIX and LIBDIR
	[ -n "$$(grep '/usr/lib/$(PKG)/$(PKG)' $(CURDIR)/debian/$(PKG)/usr/bin/$(PKG))" ]

override_dh_auto_test:
#	-NOCACHE_NR_FADVISE=2 dh_auto_test -v

## http://wiki.debian.org/onlyjob/get-orig-source
PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
VER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s*([\d\.+git]+)}')
UDATE = $(shell date --rfc-3339=seconds --date='TZ="UTC" $(shell echo $(VER) | perl -ne 'print "$$1-$$2-$$3" if m/\+git(\d{4})(\d{2})(\d{2})/')')
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(VER).orig.tar.xz
	@

UURL = git://github.com/Feh/nocache.git
$(PKG)_$(VER).orig.tar.xz:
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Downloading..."
	#uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)
	git clone $(UURL) $(PKG)-$(VER) \
        || $(RM) -r $(PKG)-$(VER)
	cd $(PKG)-$(VER) \
        && git checkout v$(VER) || git checkout $$(git log -n1 --format=%h --before="$(UDATE)") \
        && [ -s ChangeLog ] || ( echo "# Generating ChangeLog..." \
           ; git log --pretty="format:%ad  %aN  <%aE>%n%n%x09* %s%n" --date=short > ChangeLog \
           ; touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
        && echo "# Setting times..." \
        && git ls-tree -r --name-only HEAD | while read F ; do touch --no-dereference -d "$$(git log -1 --format="%ai" -- "$$F")" "$$F"; done \
        && echo "# Cleaning-up..." \
        && $(RM) -rv .git .git* \
        && cd .. && echo "# Packing..." \
        && find -L "$(PKG)-$(VER)" -xdev -type f -print | LC_ALL=C sort \
        | XZ_OPT="-7v" tar -caf "$(PKG)_$(VER).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
        && $(RM) -r "$(PKG)-$(VER)"

=== debian/watch ===
# uscan(1) configuration file.
version=3

## To generate orig.tar please use "debian/rules get-orig-source".

opts=\
dversionmangle=s/\+git\d+// \
 https://github.com/Feh/nocache/tags .*/archive/v?(\d[-\d\.]+)\.tar\.gz

## nocache 1.1

=== debian/changelog ===
nocache (1.1-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Dmitry Smirnov ]
  * New upstream release.
    + fixes hang with Glibc 2.28+ (Closes: #916415).
  * Debhelper & compat to version 11.
  * Standards-Version: 4.3.0.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 04 Jan 2019 14:37:54 +1100

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: Dmitry Smirnov <onlyjob@debian.org>
-Build-Depends: debhelper (>= 9)
-# git is needed by get-orig-source
- ,git
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 11~)
+# tests:
+#    ,coreutils
+Standards-Version: 4.3.0
 Homepage: https://github.com/Feh/nocache
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/nocache.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/nocache.git
+Vcs-Browser: https://salsa.debian.org/debian/nocache
+Vcs-Git: https://salsa.debian.org/debian/nocache.git
 
 Package: nocache
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
PKG=nocache

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -v -- PREFIX=/usr LIBDIR=/lib/$(PKG)
	# check if wrapper built for correct PREFIX and LIBDIR
	[ -n "$$(grep '/usr/lib/$(PKG)/$(PKG)' $(CURDIR)/debian/$(PKG)/usr/bin/$(PKG))" ]

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	-NOCACHE_NR_FADVISE=2 dh_auto_test -v
	## #916415
	timeout 11 ./nocache apt show coreutils 1>>/dev/null
endif

## nocache 1.2

=== debian/changelog ===
nocache (1.2-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * Import upstream version 1.2, this fixes issues with increased file
    limits. Closes: 918316
  * Fix build on (most) 32 bit architectures. Closes: #1069426
    Kudos to Guillem Jover for taking care of that.
  * Simplify test so it will not time out. Closes: #918316 (again)

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sun, 07 Jul 2024 13:44:09 +0200

=== debian/rules ===
--- 
+++ 
@@ -18,5 +18,5 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 #	-NOCACHE_NR_FADVISE=2 dh_auto_test -v
 	## #916415
-	timeout 11 ./nocache apt show coreutils 1>>/dev/null
+	timeout 11 ./nocache true
 endif
